<?php
/*
** Email Reminders (emrem)
**
** Copyright (C) 2000, Rob Hudson <crh@cogit8.org>
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**
*/

// Define some colors

define("BGCOLOR",   "#789abc");
define("TEXTCOLOR", "#030303");
define("LINKCOLOR", "#9abcde");
define("TDCOLOR",   "#abcdef");
define("BOXCOLOR",  "#eeeeee");

if (!get_magic_quotes_gpc()) 
{
  set_magic_quotes_runtime(1) or die("could not enable magic quotes");
}

/*************************************************************
 * show_header()
 *************************************************************/

function show_header() 
{
  global $config;

  echo "
    <html>
    <head>
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">
      <title>Email Reminders for the Mac</title>
  ";
  if (file_exists("style.css")) 
  {
    echo "  <link rel=\"stylesheet\" href=\"style.css\" type=\"text/css\">\n";
  }
  echo "
    </head>
    <body bgcolor=\"" . BGCOLOR . "\" text=\"" . TEXTCOLOR. "\" link=\"" . LINKCOLOR. "\">
    <a href=\"" . $config['base_dir'] . "\"><h2 align=\"center\">Email Reminders for the Mac</h2></a>
  ";

}

/*************************************************************
 * show_footer()
 *************************************************************/

function show_footer () 
{
  echo "
    </body>
    </html>
  ";
}

/*************************************************************
 * show_result (title, message)
 *************************************************************/

function show_result ($title, $message) 
{
  global $PHP_SELF;
  show_header();
  echo "
    <table border=\"0\" cellspacing=\"0\" cellpadding=\"1\" width=\"600\" bgcolor=\"#000000\" align=\"center\">
      <tr>
        <td>
          <table border=\"0\" cellspacing=\"0\" cellpadding=\"3\" width=\"100%\" bgcolor=\"#ffffff\" align=\"center\">
            <tr bgcolor=\"" . TDCOLOR . "\">
              <td><b>$title</b></td>
            </tr>
            <tr>
              <td>$message</td>
            </tr>
            <tr>
              <td>&nbsp;</td>
            </tr>
            <tr>
              <td bgcolor=\"" . BOXCOLOR . "\"><a href=\"$PHP_SELF\">Return</a></td>
            </tr>
          </table>
        </td>
      </tr>
    </table>
  ";
  show_homepage();
  show_footer();

}

/*************************************************************
 * show_email (title, message)
 *************************************************************/

function show_email ($title, $message) 
{
  global $PHP_SELF;
  show_header();
  echo "
    <table border=\"0\" cellspacing=\"0\" cellpadding=\"1\" width=\"600\" bgcolor=\"#000000\" align=\"center\">
      <tr>
        <td>
          <table border=\"0\" cellspacing=\"0\" cellpadding=\"3\" width=\"100%\" bgcolor=\"#ffffff\" align=\"center\">
            <tr bgcolor=\"" . TDCOLOR . "\">
              <td><b>$title</b></td>
            </tr>
            <tr>
              <td>$message<p></td>
            </tr>
            <tr>
              <td>&nbsp;</td>
            </tr>
            <tr>
              <td bgcolor=\"" . BOXCOLOR . "\"><a href=\"$PHP_SELF\">Send Another</a></td>
            </tr>
          </table>
        </td>
      </tr>
    </table>
  ";
  show_homepage();
  show_footer();
}

/*************************************************************
 * show_homepage()
 *************************************************************/

function show_homepage() 
{
  echo "
    <p>
    <table border=\"0\" cellspacing=\"0\" cellpadding=\"1\" width=\"400\" bgcolor=\"#000000\" align=\"center\">
      <tr>
        <td>
          <table border=\"0\" cellspacing=\"0\" cellpadding=\"3\" width=\"100%\" bgcolor=\"" . BOXCOLOR . "\" align=\"center\">
            <tr>
              <td align=\"center\">
                Brought to you by <a href=\"http://www.cogit8.org/emrem/\">Email Reminders</a> and <a href=\"http://nerdvittles.com\">Nerd Vittles</a>
              </td>
            </tr>
          </table>
        </td>
      </tr>
    </table>
  ";

}

/*************************************************************
 * show_form()
 *************************************************************/

function show_form () 
{

  global $cookie_email, $PHP_SELF;
  show_header();
  JS_selectDate();
  echo "
    <form method=\"post\" name=\"emrem\" action=\"$PHP_SELF\">
    <table border=\"0\" cellspacing=\"0\" cellpadding=\"1\" width=\"600\" bgcolor=\"#000000\" align=\"center\">
      <tr>
        <td>
          <table border=\"0\" cellspacing=\"0\" cellpadding=\"3\" width=\"100%\" bgcolor=\"#ffffff\" align=\"center\">
            <tr bgcolor=\"" . TDCOLOR . "\">
              <td colspan=\"2\">
                <b>When & Where</b>
              </td>
            </tr>
            <tr>
              <th bgcolor=\"" . BOXCOLOR . "\" align=\"right\">Email</th>
              <td><input type=\"text\" name=\"email[email]\" size=\"40\" value=\"$cookie_email\">
            </tr>
            <tr>
              <th bgcolor=\"" . BOXCOLOR . "\" valign=\"top\" align=\"right\">
                <a href=\"javascript: selectDate();\" title=\"Pop up calendar to select a date\" 
                  onMouseOver=\"window.status='Pop up a calendar to select a date';return true;\"
                  onMouseOut=\"window.status='';return true;\"><img src=\"images/calendar.png\" border=\"0\" height=\"20\" alt=\"Pop up a calendar to select a date\"></a>&nbsp;Date
               </th>
               <td>
                 <select name=\"date[month]\">
  ";
    for ($i = 1; $i < 13; $i++) 
    {
      if ($i == date ("n")) 
      {
        echo "    <option value=\"$i\" selected> ";
      } 
      else 
      {
        echo "    <option value=\"$i\"> ";
      }
      echo date ("F", mktime(0,0,0,$i,1,date("Y"))) . "\n";
    }
  echo "
    </select>
    &nbsp;
    <select name=\"date[day]\">
  ";
    for ($i = 1; $i < 32; $i++) 
    {
      if ($i == date ("j")) 
      {
        echo "    <option value=\"$i\" selected> $i\n";
      } 
      else 
      {
        echo "    <option value=\"$i\"> $i\n";
      }
    }
  echo "
    </select>
    &nbsp;
    <select name=\"date[year]\">
  ";
  for ($i = 0; $i < 9; $i++) 
  {
    echo "    <option value=" . (date("Y")+$i) . "> " . (date("Y")+$i) . "\n";
  }
  echo "
    </select>
    </td>
  </tr>
  <tr>
   <th bgcolor=\"" . BOXCOLOR . "\" align=\"right\">Time</th>
   <td>
    <select name=\"date[time]\">
  ";
    // $now_hour = date("G");  // Reverse the commenting on these lines if you want
    $now_hour = 12;            // the current hour to be selected.
    for ($i = 0; $i < 24 ; $i++) 
    {
      switch ($i) 
      {
        case 0;
          echo "    <option value=\"$i\"";
          if ($now_hour == $i) { echo " selected"; }
          echo "> 12 Midnight\n";
          break;
        case 12:
          echo "    <option value=\"$i\"";
          if ($now_hour == $i) { echo " selected"; }
          echo "> 12 Noon\n";
          break;
        case ($i< 13):
          echo "    <option value=\"$i\"";
          if ($now_hour == $i) { echo " selected"; }
          echo "> $i AM\n";
          break;
        case ($i > 12);
          echo "    <option value=\"$i\"";
          if ($now_hour == $i) { echo " selected"; }
          echo "> " . ($i-12) . " PM\n";
          break;
      }
    }
  echo "
              </select>
            </td>
          </tr>
          <tr bgcolor=\"" . TDCOLOR . "\">
            <td colspan=\"2\">
              <b>Recurring Event?</b>
            </td>
          </tr>
          <tr>
            <th bgcolor=\"" . BOXCOLOR . "\" align=\"right\">Recurrance</th>
            <td>
              Every <input type=\"text\" name=\"recur[every]\" size=\"5\">
              &nbsp;
              <select name=\"recur[interval]\" size=\"1\">
                <option value=\"hour\">hour(s)</option>
                <option value=\"day\">day(s)</option>
                <option value=\"month\">month(s)</option>
                <option value=\"year\">year(s)</option>
              </select>
            </td>
          </tr>
          <tr bgcolor=\"" . TDCOLOR . "\">
            <td colspan=\"2\"><b>Message</b></td>
          </tr>
          <tr>
            <th bgcolor=\"" . BOXCOLOR . "\" align=\"right\">Subject</th>
            <td><input type=\"text\" name=\"email[subject]\" size=\"40\"></td>
          </tr>
          <tr>
            <th bgcolor=\"" . BOXCOLOR . "\" align=right>Message</th>
            <td><textarea name=\"email[body]\" cols=\"40\" rows=\"4\" wrap=\"virtual\"></textarea></td>
          </tr>
          <tr bgcolor=\"" . BOXCOLOR . "\" align=right>
            <td colspan=\"2\" align=\"center\"><input type=\"submit\" value=\"Send Reminder\"></td>
          </tr>
        </table>
      </td>
    </tr>
  </table>
  </form>
  ";
  show_homepage();
  show_footer();
}

/*************************************************************
 * JS_selectDate ()
 *************************************************************/

function JS_selectDate () 
{
  global $config;

  ?>
  <script language=javascript>
  <!-- 
  function selectDate() 
  {
    var m_idx = document.forms["emrem"].elements["date[month]"].selectedIndex;
    var d_idx = document.forms["emrem"].elements["date[day]"].selectedIndex;
    var y_idx = document.forms["emrem"].elements["date[year]"].selectedIndex;
    var month = document.forms["emrem"].elements["date[month]"].options[m_idx].value;
    var day   = document.forms["emrem"].elements["date[day]"].options[d_idx].value;
    var year  = document.forms["emrem"].elements["date[year]"].options[y_idx].value;
    remote=window.open('<?= $config['base_url'] ?>emremcal.php?m='+month+'&d='+day+'&y='+year, 'cal', 'width=300,height=300,resizable=yes,scrollbars=no,status=0');
    if (remote != null) 
    {
      if (remote.opener == null) 
      {
        remote.opener = self;
      }
    }
  }
  // -->
  </script>
  <?

}

/*************************************************************
 * show_mini_cal (int day, int month, int year)
 *************************************************************/

function show_mini_cal ($d, $m, $y) 
{

  global $PHP_SELF;

  $first_day = mktime(0,0,0,$m,1,$y);  // first day of the month (UNIX)
  $current_day = $first_day;           // current day (used in loop below)
  $last_day  = mktime(0,0,0,($m+1),0,$y); // last day of the month (UNIX)
  $first_dow = date("w", $first_day);  // day of the week to test for Sunday
  $last_dow  = date("w", $last_day);
  $num_days  = date("t", $first_day);  // Number of days in this month

  $print_month = date("F", $first_day);
  $print_year  = date("Y", $first_day);

  echo "
    <table cellspacing=\"0\" cellpadding=\"5\" border=\"0\" width=\"230\" align=\"center\">
    <tr>
      <td align=\"left\" valign=\"middle\" width=\"50%\">
        <a href=\"$PHP_SELF?d=$d&m=".($m-1)."&y=$y\"><big><b>&#171;</b></big></a>
      </td>
      <td align=\"center\" valign=\"middle\">
        <b>$print_month<br>$print_year</b>
      </td>
      <td align=\"right\" valign=\"middle\" width=\"50%\">
        <a href=\"$PHP_SELF?d=$d&m=".($m+1)."&y=$y\"><big><b>&#187;</b></big></a>
      </td>
    </tr>
    </table>

    <table cellspacing=\"1\" cellpadding=\"0\" border=\"0\" align=\"center\" valign=\"middle\" width=\"230\">
      <tr>
        <td bgcolor=\"black\">
          <table cellspacing=\"1\" cellpadding=\"5\" border=\"0\" width=\"100%\">
          <tr bgcolor=".TDCOLOR.">
            <th>Su</th>
            <th>M </th>
            <th>Tu</th>
            <th>W </th>
            <th>Th</th>
            <th>F </th>
            <th>Sa</th>
          </tr>
          <tr>
  ";

  $tdcount = 0;

  // Print last months days up to the first day of current month
  if ($first_dow != 0) 
  {
    $first_sunday = $first_day;
    // Find the first Sunday
    while (date("w", $first_sunday) != 0) 
    {
      $first_sunday -= 86400;
    }
    while ($first_sunday < $first_day) 
    {
      _make_day_cell($first_sunday, 'gainsboro');
      ++$tdcount;
      $first_sunday += 86400;
    }
  }

  for ($daycount = 0; $daycount < $num_days; $daycount++) 
  {
    ++$tdcount;

    _make_day_cell($current_day, 'white');

    if ($tdcount%7 == 0) 
    {
      $tdcount = 0;
      echo "</tr>\n<tr>\n";
    }

    $current_day += 86400;
  }

  if ($last_dow != 6) 
  {
    $next_month = mktime(0,0,0,($m+1),1,$y); // first day of next month
    while (date("w",$next_month) != 0) 
    {
      _make_day_cell ($next_month, 'gainsboro');
      $next_month += 86400;
    }
  }

  echo "
            </tr>
          </table>
        </td>
      </tr>
    </table>
  ";

}

/*
 * Internal Functions
 */

/*************************************************************
 * _make_day_cell (timestamp, hex color)
 *************************************************************/

function _make_day_cell ($stamp, $color) 
{
  // override color if it is today
  if ($stamp == mktime(0,0,0)) 
  {
    $color = TDCOLOR;
  }
  $day = date("j",$stamp);
  $month = date("n",$stamp);
  $year = date("Y",$stamp);
  echo "\t<td align=\"center\" bgcolor=\"$color\"><a href=\"javascript: setDate($day,$month,$year);\">$day</a></td>\n";
}

?>
